;;;
;;; This file is *NOT* part of GNU Emacs.
;;;
;;; This code, the source, and makefile are released under GNU GPL.
;;;
;;; 1.1 - now accepts window handle as decimal string, first release with emwinmsg.el
;;;

(defun win32-maximize-frame ()
"Maximizes the currently selected Emacs frame."
  (interactive)
  (shell-command (format "%s/bin/emwinmsg.exe hwnd:%s show max"
						 (getenv "emacs_dir")
						 (cdr (assq 'window-id (frame-parameters (selected-frame))))
						 ))
  (message "frame maximized")
  )

(defun win32-minimize-frame ()
"Minimizes the currently selected Emacs frame."
  (interactive)
  (shell-command (format "%s/bin/emwinmsg.exe hwnd:%s show min"
						 (getenv "emacs_dir")
						 (cdr (assq 'window-id (frame-parameters (selected-frame))))
						 ))
  (message "frame maximized")
  )

(defun win32-restore-frame ()
"Maximizes the currently selected Emacs frame."
  (interactive)
  (shell-command (format "%s/bin/emwinmsg.exe hwnd:%s show restore"
						 (getenv "emacs_dir")
						 (cdr (assq 'window-id (frame-parameters (selected-frame))))
						 ))
  (message "frame maximized")
  )
